&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */
DEFINE INPUT  PARAMETER phTT AS HANDLE      NO-UNDO.

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE hBuf     AS HANDLE      NO-UNDO.
DEFINE VARIABLE hCol     AS HANDLE      NO-UNDO.
DEFINE VARIABLE hCopy    AS HANDLE      NO-UNDO.
DEFINE VARIABLE hQry     AS HANDLE      NO-UNDO.
DEFINE VARIABLE iCol     AS INTEGER     NO-UNDO.
DEFINE VARIABLE iLastRow AS INTEGER     NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME
&Scoped-define BROWSE-NAME BR-BROWSE

/* Definitions for FRAME DEFAULT-FRAME                                  */

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS BR-BROWSE 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_File 
       MENU-ITEM m_Exit         LABEL "Exit"          
       RULE
       MENU-ITEM m_Add          LABEL "Add"           
       MENU-ITEM m_Copy         LABEL "Copy"          
       MENU-ITEM m_Delete       LABEL "Delete"        .

DEFINE SUB-MENU m_Nav 
       MENU-ITEM m_First        LABEL "First"         
       MENU-ITEM m_Previous     LABEL "Previous"      
       MENU-ITEM m_Next         LABEL "Next"          
       MENU-ITEM m_Last         LABEL "Last"          .

DEFINE MENU MENU-BAR-C-Win MENUBAR
       SUB-MENU  m_File         LABEL "File"          
       SUB-MENU  m_Nav          LABEL "Nav"           .


/* Definitions of the field level widgets                               */

/* Browse definitions                                                   */
DEFINE BROWSE BR-BROWSE
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BR-BROWSE C-Win _STRUCTURED
  
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-COLUMN-SCROLLING SEPARATORS SIZE 131 BY 21.91 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     BR-BROWSE AT ROW 1.24 COL 2 WIDGET-ID 300
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 133 BY 22.33.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Temp-Table Examiner"
         HEIGHT             = 22.29
         WIDTH              = 132.6
         MAX-HEIGHT         = 45.05
         MAX-WIDTH          = 256
         VIRTUAL-HEIGHT     = 45.05
         VIRTUAL-WIDTH      = 256
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = yes
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-C-Win:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME                                                           */
/* BROWSE-TAB BR-BROWSE 1 DEFAULT-FRAME */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BR-BROWSE
/* Query rebuild information for BROWSE BR-BROWSE
     _Query            is NOT OPENED
*/  /* BROWSE BR-BROWSE */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME DEFAULT-FRAME
/* Query rebuild information for FRAME DEFAULT-FRAME
     _Query            is NOT OPENED
*/  /* FRAME DEFAULT-FRAME */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Temp-Table Examiner */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Temp-Table Examiner */
DO:
  /* This event will close the window and terminate the procedure.  */
  hQry:QUERY-CLOSE().
  DELETE OBJECT hQry.
  DELETE OBJECT hCopy.
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-RESIZED OF C-Win /* Temp-Table Examiner */
DO:
  ASSIGN
    FRAME default-frame:VIRTUAL-WIDTH  = c-Win:WIDTH
    FRAME default-frame:VIRTUAL-HEIGHT = c-Win:HEIGHT
    FRAME default-frame:WIDTH          = c-Win:WIDTH
    FRAME default-frame:HEIGHT         = c-Win:HEIGHT
    BROWSE br-browse   :WIDTH          = FRAME default-frame:WIDTH - 2
    BROWSE br-browse   :HEIGHT         = FRAME default-frame:HEIGHT - .5
    NO-ERROR.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BR-BROWSE
&Scoped-define SELF-NAME BR-BROWSE
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BR-BROWSE C-Win
ON END-RESIZE OF BR-BROWSE IN FRAME DEFAULT-FRAME
DO:
  MESSAGE PROGRAM-NAME(1)
    VIEW-AS ALERT-BOX INFO BUTTONS OK.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BR-BROWSE C-Win
ON ROW-LEAVE OF BR-BROWSE IN FRAME DEFAULT-FRAME
DO:
  DEFINE VARIABLE hFld AS HANDLE      NO-UNDO.
  
  IF BROWSE BR-BROWSE:CURRENT-ROW-MODIFIED THEN DO:
    REPEAT iCol = 1 TO BROWSE BR-BROWSE:NUM-COLUMNS:
      hCol = BROWSE BR-BROWSE:GET-BROWSE-COLUMN(iCol).
      IF hCol:MODIFIED THEN DO:
        hFld = hCol:BUFFER-FIELD.
        DO TRANSACTION:
          hQry:GET-CURRENT(EXCLUSIVE-LOCK).
          IF hFld NE ? THEN
            hFld:BUFFER-VALUE = hCol:SCREEN-VALUE.
          hBuf:BUFFER-RELEASE().
        END. /* do trans */
      END. /* hCol modified */
    END. /* repeat */
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BR-BROWSE C-Win
ON VALUE-CHANGED OF BR-BROWSE IN FRAME DEFAULT-FRAME
DO:
  RUN setSensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Add
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Add C-Win
ON CHOOSE OF MENU-ITEM m_Add /* Add */
DO:
  
  DO TRANSACTION:
    hBuf:BUFFER-CREATE().
    BROWSE BR-BROWSE:INSERT-ROW().
    iLastRow = iLastRow + 1.
  END.
  hQry:QUERY-OPEN().

  RUN setSensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Copy
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Copy C-Win
ON CHOOSE OF MENU-ITEM m_Copy /* Copy */
DO:
  DO TRANSACTION:
    hCopy:BUFFER-CREATE().
    hCopy:BUFFER-COPY(hBuf).
    BROWSE BR-BROWSE:INSERT-ROW().
    iLastRow = iLastRow + 1.
  END.
  hQry:QUERY-OPEN().

  RUN setSensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Delete
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Delete C-Win
ON CHOOSE OF MENU-ITEM m_Delete /* Delete */
DO:
  MESSAGE "Delete this record?"
    VIEW-AS ALERT-BOX WARNING BUTTONS OK-CANCEL
    UPDATE lDel AS LOGICAL.

  IF lDel THEN DO TRANSACTION:
    hQry:GET-CURRENT(EXCLUSIVE-LOCK).
    hBuf:BUFFER-DELETE().
    BROWSE BR-BROWSE:DELETE-CURRENT-ROW().
    iLastRow = iLastRow - 1.

    RUN setSensitive.
  END.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Exit
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Exit C-Win
ON CHOOSE OF MENU-ITEM m_Exit /* Exit */
DO:
  APPLY "CLOSE":U TO THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_First
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_First C-Win
ON CHOOSE OF MENU-ITEM m_First /* First */
DO:
  hQry:REPOSITION-TO-ROW(1).
  RUN setSensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Last
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Last C-Win
ON CHOOSE OF MENU-ITEM m_Last /* Last */
DO:
  hQry:GET-LAST().
  hQry:REPOSITION-TO-ROW(hQry:CURRENT-RESULT-ROW).
  RUN setSensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Next
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Next C-Win
ON CHOOSE OF MENU-ITEM m_Next /* Next */
DO:
  hQry:GET-PREV().
  hQry:REPOSITION-FORWARD(1).
  RUN setSensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Previous
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Previous C-Win
ON CHOOSE OF MENU-ITEM m_Previous /* Previous */
DO:
  hQry:GET-PREV().
  hQry:REPOSITION-BACKWARD(1).
  RUN setSensitive.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  
  APPLY "WINDOW-RESIZED":U TO c-Win.

  BROWSE BR-BROWSE:ROW-MARKERS = YES.

  RUN enable_UI.
  
  hBuf = phTT:DEFAULT-BUFFER-HANDLE.

  CREATE QUERY hQry.
  hQry:SET-BUFFERS(hBuf).
  hQry:QUERY-PREPARE("FOR EACH " + phTT:NAME).
  hQry:QUERY-OPEN().
  
  BROWSE BR-BROWSE:READ-ONLY = NO.
  
  BROWSE BR-BROWSE:QUERY = hQry.
  BROWSE BR-BROWSE:SENSITIVE = YES.
  
  BROWSE BR-BROWSE:COLUMN-RESIZABLE = YES.
  
  DO iCol = 1 TO hBuf:NUM-FIELDS:
    IF hBuf:BUFFER-FIELD(iCol):DATA-TYPE BEGINS "char" THEN
      hBuf:BUFFER-FIELD(iCol):FORMAT = "x(256)".
    ELSE IF hBuf:BUFFER-FIELD(iCol):DATA-TYPE BEGINS "int" THEN
      hBuf:BUFFER-FIELD(iCol):FORMAT = ">>>999999".
    hBuf:BUFFER-FIELD(iCol):VALIDATE-EXPRESSION = "".
    hCol = BROWSE BR-BROWSE:ADD-LIKE-COLUMN(hBuf:BUFFER-FIELD(iCol)).
    hCol:READ-ONLY = FALSE.
    hCol:WIDTH-CHARS = 15.
  END.
  
  hQry:GET-LAST().
  iLastRow = hQry:CURRENT-RESULT-ROW.
  hQry:GET-FIRST().
  
  CREATE BUFFER hCopy FOR TABLE phTT.
  
  STATUS INPUT OFF.
  RUN setSensitive.

  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  VIEW FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setSensitive C-Win 
PROCEDURE setSensitive :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE iCurrRow AS INTEGER     NO-UNDO.
  
  IF hQry:NUM-RESULTS GT 0 THEN
    iCurrRow = hQry:CURRENT-RESULT-ROW.
  
  ASSIGN
    MENU-ITEM m_First:SENSITIVE    IN MENU menu-bar-c-win = (iCurrRow GT 1)
    MENU-ITEM m_Previous:SENSITIVE IN MENU menu-bar-c-win = (iCurrRow GT 1)
    MENU-ITEM m_Next:SENSITIVE     IN MENU menu-bar-c-win = (iCurrRow NE iLastRow)
    MENU-ITEM m_Last:SENSITIVE     IN MENU menu-bar-c-win = (iCurrRow NE iLastRow)
    MENU-ITEM m_Delete:SENSITIVE   IN MENU menu-bar-c-win = (iCurrRow NE 0)
    MENU-ITEM m_Copy:SENSITIVE     IN MENU menu-bar-c-win = (iLastRow NE 0).
  
  STATUS DEFAULT SUBSTITUTE("Record &1 of &2",iCurrRow,iLastRow).
  
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
