/*
 AddCustomerSample.p
*/
DEFINE VARIABLE cError AS CHARACTER NO-UNDO.
DEFINE VARIABLE hTT    AS HANDLE    NO-UNDO.
DEFINE VARIABLE hBuf   AS HANDLE    NO-UNDO.

RUN pug/GetCustomer.p ("", OUTPUT TABLE-HANDLE hTT).

hBuf = hTT:DEFAULT-BUFFER-HANDLE.
hBuf:FIND-FIRST().

ASSIGN
  hBuf::NAME       = "Roundtable Software"
  hBuf::Address    = "106 Mission Ct."
  hBuf::Address2   = "702B"
  hBuf::City       = "Franklin"
  hBuf::State      = "TN"
  hBuf::PostalCode = "37064"
  hBuf::Phone      = "9492662999"
  hBuf::SalesRep   = "Jaclyn Barnard"
  hBuf::RowMod     = "A".
  

RUN pug/SetCustomer.p (INPUT-OUTPUT TABLE-HANDLE hTT, OUTPUT cError).

/* Prove it! */
RUN pug/viewTempTable.w (hTT).

FINALLY:
  DELETE OBJECT hTT NO-ERROR.
END FINALLY.
